"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _graphql = require("graphql");

var _commonTags = require("common-tags");

var _gatsbyCloudinary = require("@dylanvann/gatsby-cloudinary");

function _templateObject10() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                    The max height the media will be displayed at.\n                    You probably want to use maxWidth instead of this.\n                "]);

  _templateObject10 = function _templateObject10() {
    return data;
  };

  return data;
}

function _templateObject9() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                       A base64 version of the poster.\n                    "]);

  _templateObject9 = function _templateObject9() {
    return data;
  };

  return data;
}

function _templateObject8() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                       srcSet for the poster.\n                    "]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                       src for the poster.\n                    "]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                       src for the video.\n                    "]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                        A base64 version of the image.\n                    "]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                        srcSet for the image (WebP).\n                    "]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                        src for the image (WebP).\n                    "]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                        srcSet for the image.\n                    "]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2.default)(["\n                        src for the image.\n                    "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var _default = function _default(_ref) {
  var pathPrefix = _ref.pathPrefix,
      getNodeAndSavePathDependency = _ref.getNodeAndSavePathDependency,
      reporter = _ref.reporter,
      cloudinaryConfig = _ref.cloudinaryConfig;
  return {
    type: new _graphql.GraphQLObjectType({
      name: 'ImageCloudinaryFluid',
      fields: {
        width: {
          type: _graphql.GraphQLFloat,
          description: 'The original width of the media.'
        },
        height: {
          type: _graphql.GraphQLFloat,
          description: 'The original height of the media.'
        },
        // ----------------------------------------
        // img
        // ----------------------------------------
        imgSrc: {
          type: _graphql.GraphQLString,
          description: (0, _commonTags.oneLine)(_templateObject())
        },
        imgSrcSet: {
          type: _graphql.GraphQLString,
          description: (0, _commonTags.oneLine)(_templateObject2())
        },
        imgWebPSrc: {
          type: _graphql.GraphQLString,
          description: (0, _commonTags.oneLine)(_templateObject3())
        },
        imgWebPSrcSet: {
          type: _graphql.GraphQLString,
          description: (0, _commonTags.oneLine)(_templateObject4())
        },
        imgBase64: {
          type: _graphql.GraphQLString,
          description: (0, _commonTags.oneLine)(_templateObject5())
        },
        // ----------------------------------------
        // video
        //
        // no srcSet or base64
        // as those do not make sense for videos
        // ----------------------------------------
        videoSrc: {
          type: _graphql.GraphQLString,
          description: (0, _commonTags.oneLine)(_templateObject6())
        },
        // ----------------------------------------
        // videoPoster
        // ----------------------------------------
        videoPosterSrc: {
          type: _graphql.GraphQLString,
          description: (0, _commonTags.oneLine)(_templateObject7())
        },
        videoPosterSrcSet: {
          type: _graphql.GraphQLString,
          description: (0, _commonTags.oneLine)(_templateObject8())
        },
        videoPosterBase64: {
          type: _graphql.GraphQLString,
          description: (0, _commonTags.oneLine)(_templateObject9())
        },
        sizes: {
          type: _graphql.GraphQLString
        }
      }
    }),
    args: {
      maxWidth: {
        type: _graphql.GraphQLInt,
        description: 'The max width the media will be displayed at.',
        defaultValue: 800
      },
      maxHeight: {
        type: _graphql.GraphQLInt,
        description: (0, _commonTags.oneLine)(_templateObject10())
      },
      toImgFormat: {
        type: _graphql.GraphQLString,
        description: 'Format to convert img to.'
      },
      toVideoFormat: {
        type: _graphql.GraphQLString,
        description: 'Format to convert video to.'
      },
      toVideoPosterFormat: {
        type: _graphql.GraphQLString,
        description: 'Format to convert videoPoster to.'
      }
    },
    resolve: function () {
      var _resolve = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(image, fieldArgs, context) {
        var file, path, maxWidth, props;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                file = getNodeAndSavePathDependency(image.parent, context.path);
                path = file.absolutePath;
                maxWidth = fieldArgs.maxWidth;
                props = (0, _gatsbyCloudinary.getData)({
                  path: path,
                  config: cloudinaryConfig,
                  maxWidth: maxWidth
                });
                return _context.abrupt("return", props);

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function resolve(_x, _x2, _x3) {
        return _resolve.apply(this, arguments);
      };
    }()
  };
};

exports.default = _default;