"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var extensions = ["jpeg", "jpg", "png", "webp", "tif", "tiff", "gif", "mp4", "webm", "ogv"].reduce(function (acc, v) {
  acc[v] = v;
  return acc;
}, {});

var _default = function _default(_ref) {
  var node = _ref.node,
      actions = _ref.actions,
      createNodeId = _ref.createNodeId;
  var createNode = actions.createNode,
      createParentChildLink = actions.createParentChildLink;

  if (!extensions[node.extension]) {
    return;
  }

  var imageNode = {
    id: createNodeId("".concat(node.id, " >> ImageCloudinary")),
    children: [],
    parent: node.id,
    internal: {
      contentDigest: "".concat(node.internal.contentDigest),
      type: "ImageCloudinary"
    }
  };
  createNode(imageNode);
  createParentChildLink({
    parent: node,
    child: imageNode
  });
  return;
};

exports.default = _default;